%define ptr

SECTION .DATA 

PCMPxSTRx_UNSIGNED_BYTES    EQU 0x00
PCMPxSTRx_UNSIGNED_WORDS    EQU 0x01
PCMPxSTRx_SIGNED_BYTES      EQU 0x02
PCMPxSTRx_SIGNED_WORDS      EQU 0x03
PCMPxSTRx_EQUAL_ANY         EQU 0x00
PCMPxSTRx_RANGES            EQU 0x04
PCMPxSTRx_EQUAL_EACH        EQU 0x08
PCMPxSTRx_EQUAL_ORDERED     EQU 0x0C
PCMPxSTRx_POSITIVE_POLARITY EQU 0x00
PCMPxSTRx_NEGATIVE_POLARITY EQU 0x10
PCMPxSTRx_MASKED_PLUS       EQU 0x20
PCMPxSTRx_MASKED_MINUS      EQU 0x30
PCMPxSTRi_LEAST_INDEX       EQU 0x00
PCMPxSTRi_MOST_INDEX        EQU 0x40
PCMPxSTRm_BIT_MASK          EQU 0x00
PCMPxSTRm_EXPAND_MASK       EQU 0x40

R1H EQU 0x0001
R1L EQU 0x0002
R1W EQU 0x0003
R1D EQU 0x0004
R1Q EQU 0x0005
R1M EQU 0x0008
R2H EQU 0x0010
R2L EQU 0x0020
R2W EQU 0x0030
R2D EQU 0x0040
R2Q EQU 0x0050
R2M EQU 0x0080
R3H EQU 0x0100
R3L EQU 0x0200
R3W EQU 0x0300
R3D EQU 0x0400
R3Q EQU 0x0500
R3M EQU 0x0800
R4H EQU 0x0100
R4L EQU 0x0200
R4W EQU 0x0300
R4D EQU 0x0400
R4Q EQU 0x0500
R4M EQU 0x0800

I1L EQU R1L
I1W EQU R1W
I1D EQU R1D
I1Q EQU R1Q
I2L EQU R2L
I2W EQU R2W
I2D EQU R2D
I2Q EQU R2Q
I3L EQU R3L
I3W EQU R3W
I3D EQU R3D
I3Q EQU R3Q
I4L EQU R4L
I4W EQU R4W
I4D EQU R4D
I4Q EQU R4Q

M1B EQU R1L|R1M
M1W EQU R1W|R1M
M1D EQU R1D|R1M
M1Q EQU R1Q|R1M
M2B EQU R2L|R2M
M2W EQU R2W|R2M
M2D EQU R2D|R2M
M2Q EQU R2Q|R2M
M3B EQU R3L|R3M
M3W EQU R3W|R3M
M3D EQU R3D|R3M
M3Q EQU R3Q|R3M

IMM EQU 0x01000000
MM EQU R1M|R2M

LH  EQU R1H
LL  EQU R1L
LW  EQU R1W
LD  EQU R1D
LQ  EQU R1Q
LM  EQU R1M
D1  EQU M1B
D2  EQU M1W
D4  EQU M1D
D8  EQU M1Q

RH  EQU R2H
RL  EQU R2L
RW  EQU R2W
RD  EQU R2D
RQ  EQU R2Q
RM  EQU R2M
S1  EQU M2B
S2  EQU M2W
S4  EQU M2D
S8  EQU M2Q

I1  EQU I2L
I2  EQU I2W
I4  EQU I2D
I8  EQU I2Q
X1  EQU I3L
X2  EQU I3W
X4  EQU I3D
X8  EQU I3Q

REP_ECX  EQU 0x00
REP_RCX  EQU 0x80
REP_CMPS EQU 1
REP_INS  EQU 2
REP_LODS EQU 3
REP_MOVS EQU 4
REP_OUT  EQU 5
REP_SCAS EQU 6
REP_STOS EQU 7

CF EQU 0x00000001
_1 EQU 0x00000002
PF EQU 0x00000004
_3 EQU 0x00000008
AF EQU 0x00000010
_5 EQU 0x00000020
ZF EQU 0x00000040
SF EQU 0x00000080
TF EQU 0x00000100
IF EQU 0x00000200
DF EQU 0x00000400
OF EQU 0x00000800
IOPL EQU 0x00001000
NT EQU 0x00002000
_15 EQU 0x00004000
RF EQU 0x00008000
VM EQU 0x00010000
AC EQU 0x00020000
VIF EQU 0x00040000
VIP EQU 0x00080000
ID EQU 0x00100000

E_OK EQU 0x00000000
E_FALSE EQU 0x00000001
E_ERROR EQU 0x80000000

_NONE EQU 0
_AH   EQU 1;
_BH   EQU 2;
_CH   EQU 3;
_DH   EQU 4;
_AL   EQU 5  
_AX   EQU 6  
_EAX  EQU 7  
_RAX  EQU 8
_BL   EQU 9  
_BX   EQU 10 
_EBX  EQU 11 
_RBX  EQU 12
_CL   EQU 13 
_CX   EQU 14 
_ECX  EQU 15 
_RCX  EQU 16
_DL   EQU 17 
_DX   EQU 18 
_EDX  EQU 19 
_RDX  EQU 20
_SIL  EQU 21 
_SI   EQU 22 
_ESI  EQU 23 
_RSI  EQU 24
_DIL  EQU 25 
_DI   EQU 26 
_EDI  EQU 27 
_RDI  EQU 28
_BPL  EQU 29 
_BP   EQU 30 
_EBP  EQU 31 
_RBP  EQU 32
_SPL  EQU 33 
_SP   EQU 34 
_ESP  EQU 35 
_RSP  EQU 36
_R8B  EQU 37 
_R8W  EQU 38 
_R8D  EQU 39 
_R8   EQU 40
_R9B  EQU 41 
_R9W  EQU 42 
_R9D  EQU 43 
_R9   EQU 44
_R10B EQU 45 
_R10W EQU 46 
_R10D EQU 47 
_R10  EQU 48
_R11B EQU 49 
_R11W EQU 50 
_R11D EQU 51 
_R11  EQU 52
_R12B EQU 53 
_R12W EQU 54 
_R12D EQU 55 
_R12  EQU 56
_R13B EQU 57 
_R13W EQU 58 
_R13D EQU 59 
_R13  EQU 60
_R14B EQU 61 
_R14W EQU 62 
_R14D EQU 63 
_R14  EQU 64
_R15B EQU 65 
_R15W EQU 66 
_R15D EQU 67 
_R15  EQU 68
_IPL  EQU 69 
_IP   EQU 70 
_EIP  EQU 71 
_RIP  EQU 72

ALIGN 16
lubpackedr1 db _AL+1,  _AX+1,  _BL+1,  _BX+1,  _CL+1,   _CX+1,   _DL+1,   _DX+1,      _SIL+1,  _SI+1,   _DIL+1,  _DI+1,   _BPL+1,  _BP+1,   _SPL+1,  _SP+1 
lubpackedr2 db _R8B+1, _R8W+1, _R9B+1, _R9W+1, _R10B+1, _R10W+1, _R11B+1, _R11W+1,    _R12B+1, _R12W+1, _R13B+1, _R13W+1, _R14B+1, _R14W+1, _R15B+1, _R15W+1
lubpackedrx db _R8B+1, _R15+1, _NONE,  _NONE,  _NONE,   _NONE,   _NONE,   _NONE,	  _NONE,   _NONE,   _NONE,   _NONE,   _NONE,   _NONE,   _NONE,   _NONE
lubpackedrd db _EAX+1, _EBX+1, _ECX+1, _EDX+1, _ESI+1,  _EDI+1,  _EBP+1,  _ESP+1,     _R8D+1,  _R9D+1,  _R10D+1, _R11D+1, _R12D+1, _R13D+1, _R14D+1, _R15D+1
lubpackedrq db _RAX+1, _RBX+1, _RCX+1, _RDX+1, _RSI+1,  _RDI+1,  _RBP+1,  _RSP+1,     _R8+1,   _R9+1,   _R10+1,  _R11+1,  _R12+1,  _R13+1,  _R14+1,  _R15+1

%macro EFLAGS 1
	pushfq		
	and			%1,0x00000CD5
	and			dword ptr [rsp],0xFFFFF32A
	or			dword ptr [rsp],%1
	popfq
%endmacro

%macro emu1 4
	test		r8d,MM
	jnz			.mem
	lea			r10,[%1]
	lea			r11,[%2]
	jmp			cpu_e1
.mem:
	lea			r10,[%3]
	lea			r11,[%4]
	jmp			cpu_e1
%endmacro

%macro emu2 6
	test		r9d,IMM
	jnz			.imm
	test		r9d,MM
	jnz			.mem
	lea			r10,[%1]
	lea			r11,[%2]
	jmp			cpu_e2
.mem:
	lea			r10,[%3]
	lea			r11,[%4]
	jmp			cpu_e2
.imm:
	lea			r10,[%5]
	lea			r11,[%6]
	jmp			cpu_e2
%endmacro

%macro emu3 4
	test		dword ptr [rsp+0x28],MM
	jnz			.mem
	lea			r10,[%1]
	lea			r11,[%2]
	jmp			cpu_e3
.mem:
	lea			r10,[%3]
	lea			r11,[%4]
	jmp			cpu_e3
%endmacro

%define E1 emu1 .jmpbound, .jmptable, .membound, .memtable
%define E2 emu2 .jmpbound, .jmptable, .membound, .memtable, .immbound, .immtable
%define E3 emu3 .jmpbound, .jmptable, .membound, .memtable

ALIGN 16
cpu_e1:
	test		r8d,IMM
	jnz			.break
	mov			rax,rcx
	movzx		ecx,r8b	
	movd		xmm0,ecx
	pcmpistri   xmm0,[r10],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	mov			r11,[r11+rcx*8]
	mov			r10,rdx
	mov			r9,rax
	mov			rdx,[r9]
	mov			eax,[r10]
	EFLAGS		eax
	call		r11
	pushfq
	pop			rax
	mov			[r10],eax
	mov			[r9],rdx
	mov			eax,E_OK
	ret

.break:
	mov			eax,E_ERROR
	ret		

ALIGN 16
cpu_e2:
	push		0
	mov			rax,rcx
	movzx		ecx,r9b
	movd		xmm0,ecx
	pcmpistri	xmm0,[r10],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	test		r9d,IMM
	jz			.continue
	mov			r10d,r9d
	shr			r10d,4
	and			r10d,7
	jmp			[.size+r10*8]

	ALIGN 16
.2: movsx		rdx,byte ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.3: movsx		rdx,word ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.4: movsxd		rdx,dword ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.5: mov			rdx,qword ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue

	ALIGN 16
.continue:
	mov			r11,[r11+rcx*8]
	mov			r10,r8
	mov			r9,rdx
	mov			r8,rax
	mov			rdx,[r8]
	mov			rcx,[r9]
	mov			eax,[r10]
	EFLAGS		eax
	call		r11
	pushfq
	pop			rax
	mov			[r10],eax
	mov			[r9],rcx
	mov			[r8],rdx
	mov			eax,E_OK
	pop			rdx
	ret

.break:
	mov			eax,E_ERROR
	pop			rdx	
	ret
ALIGN 16
.size: dq .break, .break, .2, .3, .4, .5, .break, .break

ALIGN 16
cpu_e3:
	push		0
	mov			rax,rcx
	movzx		ecx,word ptr [rsp+0x30]
	movd		xmm0,ecx
	pcmpistri	xmm0,[r10],1
	jae			.break
	test		dword ptr [rsp+0x30],IMM
	jz			.continue
	mov			r10d,[rsp+0x30]
	shr			r10d,8
	and			r10d,7
	jmp			[.size+r10*8]

	ALIGN 16
.2: movsx		r8,byte ptr [r8]
	mov			[rsp],r8
	mov			r8,rsp
	jmp			.continue
	ALIGN 16
.3: movsx		r8,word ptr [r8]
	mov			[rsp],r8
	mov			r8,rsp
	jmp			.continue
	ALIGN 16
.4: movsxd		r8,dword ptr [r8]
	mov			[rsp],r8
	mov			r8,rsp
	jmp			.continue
	ALIGN 16
.5: mov			r8,qword ptr [r8]
	mov			[rsp],r8
	mov			r8,rsp
	jmp			.continue

	ALIGN 16
.continue:
	push		qword ptr [r11+rcx*8]
	mov			rcx,[r8]
	mov			r10,rax
	mov			r11,rdx
	mov			rax,[rax]
	mov			rdx,[rdx]
	mov			r8d,[r9]
	EFLAGS		r8d
	call		[rsp]
	pop			rcx
	pushfq
	pop			rcx
	mov			[r9],ecx
	mov			[r10],rax
	mov			[r11],rdx
	mov			eax,E_OK
	pop			r8
	ret
	
.break:
	mov			eax,E_ERROR
	pop			r8
	ret
ALIGN 16
.size: dq .break, .break, .2, .3, .4, .5, .break, .break

ALIGN 16
cpu_rex:
	push		rcx
	movzx		ecx,cx
	add			ecx,$0101
	movd		xmm0,ecx
	pcmpistri	xmm0,[lubpackedrq],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
	movdqa		xmm1,[lubpackedrx]
	pcmpistri	xmm1,xmm0,PCMPxSTRx_UNSIGNED_BYTES | PCMPxSTRx_RANGES
	jb			.break
	mov			eax,E_FALSE
	pop			rcx
	ret

.break:
	xor			eax,eax
	pop			rcx
	ret

ALIGN 16
cpu_rextest1:
	push		rcx
	test		ecx,0x80000000
	jnz			.memory
	test		ch,ch                      
	jnz			.break
	test		cl,cl
	jnz			.leave
.break:
	pop			rcx
	mov			eax,E_ERROR
	ret
.memory:
	cmp			ch,_ESP
	je			.stack
	cmp			ch,_RSP
	jne			.h1
.stack:
	test		ecx,0x00FE0000
	jnz			.break
	cmp			ch,cl
	je			.break
.h1:
	test		cl,cl
	jz			.h2
	cmp			cl,_DH
	jbe			.break
.h2:
	test		ch,ch
	jz			.16
	cmp			ch,_DH
	jbe			.break
.16:
	movzx		ecx,cx
	add			ecx,0x00000101
	movd		xmm0,ecx
	pcmpistri	xmm0,[lubpackedr1],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
	pcmpistri	xmm0,[lubpackedr2],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
	pcmpistri   xmm0,[lubpackedrd],PCMPxSTRx_UNSIGNED_BYTES
	jae			.leave
	pcmpistri	xmm0,[lubpackedrq],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break	
.leave:
	mov			eax,E_OK
	pop			rcx
	ret

ALIGN 16
cpu_rextest2:
	push		rbx
	push		rcx
	test		ecx,$80000000              ;is R1 memory?
	setnz		bh
	test		edx,$80000000              ;is R2 memory?
	setnz		bl
	test		bx,bx                      ;both register
	jz			.register
	cmp			bl,bh                      ;both memory
	je			.break
	test		cx,cx
	setz		al                         ;is immediate?
	cmp			al,bh                      ;is immediate memory?
	jg			.break
	test		bh,bh                      ;is first operand memory?
	cmovnz		rbx,rcx                    ;rbx is memory operand
	cmovnz		rax,rdx                    ;rax is another operand
	cmovz		rbx,rdx                    ;rbx is memory operand
	cmovz		rax,rcx                    ;rax is another operand
	test		ah,ah                      ;only one operand is allowed
	jnz			.break
	test		bx,bx                      ;memory operand is immediate(eg [$00040000])
	jz			.immediate
	cmp			bh,_ESP                    ;esp*X
	je			.stack
	cmp			bh,_RSP                    ;rsp*X
	jne			.h1
.stack:
	test		ebx,$00FE0000              ;esp/rsp implicit x1 allowed
	jnz			.break
	cmp			bh,bl                      ;esp+esp / rsp+rsp
	je			.break
.h1:
	test		bl,bl
	jz			.h2
	cmp			bl,_DH                     ;ah bh ch dh
	jbe			.break
.h2:
	test		bh,bh
	jz			.memory
	cmp			bh,_DH                     ;ah bh ch dh
	jbe			.break
.memory:
	movzx		ebx,bx
	add			ebx,0x00000101
	movd		xmm0,ebx
	pcmpistri	xmm0,[lubpackedr1],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
	pcmpistri	xmm0,[lubpackedr2],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
	pcmpistri   xmm0,[lubpackedrd],PCMPxSTRx_UNSIGNED_BYTES
	jae			.test
	pcmpistri   xmm0,[lubpackedrq],PCMPxSTRx_UNSIGNED_BYTES
	jb			.break
.test:
	test		ax,ax                      ;second operand is immediate
	jz			.leave
	cmp			al,4                       ;ah bh ch dh
	ja			.leave
	mov			eax,$00004526              ;r8* - r15*
	movd		xmm1,eax
	pcmpistri	xmm1,xmm0,0x04 
	jae			.leave
	jmp			.break
.immediate:
	test		ax,ax                      
	jnz			.leave
	and			ebx,$7F000000
	and			eax,$7F000000
	cmp			eax,ecx
	je			.leave
	jmp			.break
.register:
	test		cx,cx                      ;immediate cannot be destination
	jz			.break
	test		ecx,$0000FF00              ;only one register allowed
	jnz			.break
	test		edx,$0000FF00              ;only one register allowed
	jnz			.break
	test		dx,dx
	jz			.leave                     ;second operand is immediate
	mov			eax,edx
	cmp			cl,_DH                     ;ah bh ch dh
	jbe			.rex
	mov			eax,ecx
	cmp			dl,_DH                     ;ah bh ch dh
	ja			.leave
.rex:
	cmp			al,_R8B                    ;r8*-r15*
	jae			.break
	cmp			al,_SIL                    
	je			.break
	cmp			al,_DIL                      
	je			.break
	cmp			al,_BPL                      
	je			.break
	cmp			al,_SPL                      
	je			.break
.leave:
	mov			eax,E_OK
	pop			rcx
	pop			rbx
	ret

.break:
	mov			eax,E_ERROR
	pop			rcx
	pop			rbx
	ret

;ADC
ALIGN 16
cpu_adc:
	E2
	ALIGN 16
.0: adc			dl,cl
	ret
	ALIGN 16
.1: adc			dl,ch
	ret
	ALIGN 16
.2: adc			dh,cl
	ret
	ALIGN 16
.3:	adc			dh,ch
	ret
	ALIGN 16
.4:	adc			dx,cx
	ret
	ALIGN 16
.5:	adc			edx,ecx
	ret
	ALIGN 16
.6:	adc			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	adc			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;ADD
ALIGN 16
cpu_add:
	E2
	ALIGN 16
.0: add			dl,cl
	ret
	ALIGN 16
.1: add			dl,ch
	ret
	ALIGN 16
.2: add			dh,cl
	ret
	ALIGN 16
.3:	add			dh,ch
	ret
	ALIGN 16
.4:	add			dx,cx
	ret
	ALIGN 16
.5:	add			edx,ecx
	ret
	ALIGN 16
.6:	add			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	add			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;AND
ALIGN 16
cpu_and:
	E2
	ALIGN 16
.0: and			dl,cl
	ret
	ALIGN 16
.1: and			dl,ch
	ret
	ALIGN 16
.2: and			dh,cl
	ret
	ALIGN 16
.3:	and			dh,ch
	ret
	ALIGN 16
.4:	and			dx,cx
	ret
	ALIGN 16
.5:	and			edx,ecx
	ret
	ALIGN 16
.6:	and			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	and			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;BSF
ALIGN 16
cpu_bsf:
	E2
	ALIGN 16
.0: bsf			dx,cx 
	ret
	ALIGN 16
.1:	bsf			edx,ecx
	ret
	ALIGN 16
.2:	bsf			rdx,rcx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .2
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;BSR
ALIGN 16
cpu_bsr:
	E2
	ALIGN 16
.0: bsr			dx,cx 
	ret
	ALIGN 16
.1:	bsr			edx,ecx
	ret
	ALIGN 16
.2:	bsr			rdx,rcx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .2
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;BSWAP
ALIGN 16
cpu_bswap:
	E1
	ALIGN 16
.0:	bswap		edx
	ret
	ALIGN 16
.1:	bswap		rdx
	ret
ALIGN 16
.jmpbound: db LD, LQ, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.jmptable: dq .0, .1
ALIGN 16
.membound: db 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.memtable:

;BT
ALIGN 16
cpu_bt:
	E2
	ALIGN 16
.0:	bt			dx,cx
	ret
	ALIGN 16
.1:	bt			edx,ecx
	ret
	ALIGN 16
.2: bt			rdx,rcx
	ret
	ALIGN 16
.3: push		rdx
	bt			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .3,    .2
ALIGN 16
.immbound: db LW|I1, LD|I1, LQ|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .0,    .3,    .2

;BTC
ALIGN 16
cpu_btc:
	E2
	ALIGN 16
.0:	btc			dx,cx
	ret
	ALIGN 16
.1:	btc			edx,ecx
	ret
	ALIGN 16
.2: btc			rdx,rcx
	ret
	ALIGN 16
.3: push		rdx
	btc			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .3,    .2
ALIGN 16
.immbound: db LW|I1, LD|I1, LQ|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .0,    .3,    .2

;BTR
ALIGN 16
cpu_btr:
	E2
	ALIGN 16
.0:	btr			dx,cx
	ret
	ALIGN 16
.1:	btr			edx,ecx
	ret
	ALIGN 16
.2: btr			rdx,rcx
	ret
	ALIGN 16
.3: push		rdx
	btr			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .3,    .2
ALIGN 16
.immbound: db LW|I1, LD|I1, LQ|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .0,    .3,    .2

;BTS
ALIGN 16
cpu_bts:
	E2
	ALIGN 16
.0:	bts			dx,cx
	ret
	ALIGN 16
.1:	bts			edx,ecx
	ret
	ALIGN 16
.2: bts			rdx,rcx
	ret
	ALIGN 16
.3: push		rdx
	bts			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .3,    .2
ALIGN 16
.immbound: db LW|I1, LD|I1, LQ|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .0,    .3,    .2

;CBW
ALIGN 16
cpu_cbw:
	mov			rax,[rcx]
	cbw
	mov			[rcx],rax
	mov			eax,E_OK
	ret

;CWDE
ALIGN 16
cpu_cwde:
	mov			rax,[rcx]
	cwde
	mov			[rcx],rax
	mov			eax,E_OK
	ret

;CDQE
ALIGN 16
cpu_cdqe:
	mov			rax,[rcx]
	cdqe
	mov			[rcx],rax
	mov			eax,E_OK
	ret

;CLC
ALIGN 16
cpu_clc:
	and			dword ptr [rcx],~CF
	mov			eax,E_OK
	ret

;CLD
ALIGN 16
cpu_cld:
	and			dword ptr [rcx],~DF
	mov			eax,E_OK
	ret

;CMC
ALIGN 16
cpu_cmc:
	xor			dword ptr [rcx],CF
	mov			eax,E_OK
	ret

;CMOVCC
ALIGN 16
cpu_cmovcc:
	test		r9d,IMM
	jnz			.break
	test		r9d,LM
	jnz			.break
	mov			eax,r9d
	shr			eax,16
	and			eax,255
	cmp			eax,29
	ja			.break
	mov			r10d,eax
	mov			rax,[rcx]
	mov			rdx,[rdx]
	and			r9d,~MM
	and			r9d,0xFF
	jmp			[.cmovcc+r10*8]

.c00:ja			.mov 
	 jmp		.nop
.c01:jae		.mov 
	 jmp		.nop
.c02:jb			.mov 
	 jmp		.nop
.c03:jbe		.mov 
	 jmp		.nop
.c04:jc			.mov 
	 jmp		.nop
.c05:je			.mov 
	 jmp		.nop
.c06:jg			.mov 
	 jmp		.nop
.c07:jge		.mov 
	 jmp		.nop
.c08:jl			.mov 
	 jmp		.nop
.c09:jle		.mov 
	 jmp		.nop
.c10:jna		.mov 
	 jmp		.nop
.c11:jnae		.mov 
	 jmp		.nop
.c12:jnb		.mov 
	 jmp		.nop
.c13:jnbe		.mov 
	 jmp		.nop
.c14:jnc		.mov 
	 jmp		.nop
.c15:jne		.mov 
	 jmp		.nop
.c16:jng		.mov 
	 jmp		.nop
.c17:jnge		.mov 
	 jmp		.nop
.c18:jnl		.mov 
	 jmp		.nop
.c19:jnle		.mov 
	 jmp		.nop
.c20:jno		.mov 
	 jmp		.nop
.c21:jnp		.mov 
	 jmp		.nop
.c22:jns		.mov 
	 jmp		.nop
.c23:jnz		.mov 
	 jmp		.nop
.c24:jo			.mov 
	 jmp		.nop
.c25:jp			.mov 
	 jmp		.nop
.c26:jpe		.mov 
	 jmp		.nop
.c27:jpo		.mov 
	 jmp		.nop
.c28:js			.mov 
	 jmp		.nop
.c29:jz			.mov
	 jmp		.nop

ALIGN 16
.mov:
	cmp			r9d,LQ|RQ
	je			.64
	cmp			r9d,LD|RD
	je			.32
	cmp			r9d,LW|RW
	je			.16
	mov			eax,E_ERROR
	ret

ALIGN 16
.64:mov			rax,rdx
	mov			[rcx],rax
	mov			eax,E_OK
	ret

ALIGN 16
.32:mov			eax,edx
	mov			[rcx],rax
	mov			eax,E_OK
	ret

ALIGN 16
.16:mov			ax,dx
	mov			[rcx],rax
	mov			eax,E_OK
	ret

ALIGN 16
.nop:
	cmp			r9d,LQ|RQ
	je			.false
	cmp			r9d,LW|RW
	je			.false
	mov			eax,eax
	cmp			r9d,LD|RD
	jne			.break

.false:
	mov			[rcx],rax
	mov			eax,E_FALSE
	ret

ALIGN 16
.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.cmovcc: dq .c00,.c01,.c02,.c03,.c04,.c05,.c06,.c07,.c08,.c09,.c10,.c11,.c12,.c13,.c14,.c15,.c16,.c17,.c18,.c19,.c20,.c21,.c22,.c23,.c24,.c25,.c26,.c27,.c28,.c29

;CMP
ALIGN 16
cpu_cmp:
	E2
	ALIGN 16
.0: cmp			dl,cl
	ret
	ALIGN 16
.1: cmp			dl,ch
	ret
	ALIGN 16
.2: cmp			dh,cl
	ret
	ALIGN 16
.3:	cmp			dh,ch
	ret
	ALIGN 16
.4:	cmp			dx,cx
	ret
	ALIGN 16
.5:	cmp			edx,ecx
	ret
	ALIGN 16
.6:	cmp			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	cmp			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00 
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;CMPS
ALIGN 16
cpu_cmps:
	movzx		eax,byte ptr [rsp+0x30]
	test		eax,IMM
	jnz			.break
	mov			r10,rcx
	mov			r11,rdx
	movd		xmm0,eax
	pcmpistri	xmm0,[.cmpsbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	push		rsi
	push		rdi
	mov			rsi,r8
	mov			rdi,r9
	mov			rax,[rsp+0x38]
	mov			edx,[rax]
	EFLAGS		edx
	jmp			[.cmpstable+rcx*8]

	ALIGN 16
.0: cmpsb
	jmp			.continue
	ALIGN 16
.1:	cmpsw
	jmp			.continue
	ALIGN 16
.2:	cmpsd
	jmp			.continue
	ALIGN 16
.3:	cmpsq
	jmp			.continue

.continue:	
	pushfq
	pop			rdx
	mov			[rax],edx
	sub			r8,rsi
	sub			[r10],r8
	sub			r9,rdi
	sub			[r11],r9
	mov			eax,E_OK
	pop			rdi
	pop			rsi
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.cmpsbound: db D1|S1, D2|S2, D4|S4, D8|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.cmpstable: dq  .0,    .1,    .2,    .3

;CMPXCHG
ALIGN 16
cpu_cmpxchg:
	mov			rax,rcx
	mov			ecx,[rsp+0x28]
	test		ecx,IMM
	jnz			.break
	test		ecx,MM
	jnz			.normal
	cmp			rdx,r8
	jne			.normal
	lea			r10,[.cmpxchgsbound]
	lea			r11,[.cmpxchgstable]
	jmp			.next

.normal:
	lea			r10,[.cmpxchgdbound]
	lea			r11,[.cmpxchgdtable]

.next:
	movzx		ecx,cl
	movd		xmm0,ecx
	pcmpistri	xmm0,[r10],0
	jae			.break
	push		qword ptr [r11+rcx*8]
	mov			r10,rax
	mov			r11,rdx
	mov			rax,[r10]
	mov			rdx,[r11]
	mov			rcx,[r8]
	mov			r8d,[r9]			
	EFLAGS		r8d
	ret
	
.s0:cmpxchg		dl,dl
	jmp			.continue
.s1:cmpxchg		dl,dh
	jmp			.continue
.s2:cmpxchg		dh,dl
	jmp			.continue
.s3:cmpxchg		dh,dh
	jmp			.continue
.s4:cmpxchg		dx,dx
	jmp			.continue
.s5:cmpxchg		edx,edx
	jmp			.continue
.s6:cmpxchg		rdx,rdx
	jmp			.continue
.d0:cmpxchg		dl,cl
	jmp			.continue
.d1:cmpxchg		dl,ch
	jmp			.continue
.d2:cmpxchg		dh,cl
	jmp			.continue
.d3:cmpxchg		dh,ch
	jmp			.continue
.d4:cmpxchg		dx,cx
	jmp			.continue
.d5:cmpxchg		edx,ecx
	jmp			.continue
.d6:cmpxchg		rdx,rcx
	jmp			.continue
.d7:push		rdx
	cmpxchg		dword ptr [rsp],ecx
	pop			rdx

.continue:
	pushfq		
	pop			rcx
	mov			[r9],ecx
	mov			[r10],rax
	mov			[r11],rdx
	mov			eax,E_OK
	ret
	
.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.cmpxchgsbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.cmpxchgstable: dq  .s0,   .s1,   .s2,   .s3,   .s4,   .s5,   .s6
ALIGN 16
.cmpxchgdbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00
.cmpxchgdtable: dq  .d0,   .d1,   .d2,   .d3,   .d4,   .d5,   .d6,   .d0,	.d1,   .d4,   .d7,   .d6

;CPUID
ALIGN 16
cpu_cpuid:
	push		rbx
	mov			r10,rcx
	mov			r11,rdx
	mov			rax,[rcx]
	mov			rbx,[rdx]
	mov			rcx,[r8]
	mov			rdx,[r9]
	cpuid
	mov			[r10],rax
	mov			[r11],rbx
	mov			[r8],rcx
	mov			[r9],rdx
	mov			eax,E_OK
	pop			rbx
	ret

;CRC32
ALIGN 16
cpu_crc32:
	E2
.0: crc32		edx,cl
	ret
.1:	crc32		edx,ch
	ret
.2: crc32		edx,cx
	ret
.3: crc32		edx,ecx
	ret
.4: crc32		rdx,cl
	ret
.5: crc32		rdx,rcx
	ret
ALIGN 16
.jmpbound: db LD|RL, LD|LH, LD|RW, LD|RD, LQ|RL, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5
ALIGN 16
.membound: db LD|S1, LD|S2, LD|S4, LQ|S1, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .3,    .4,    .5
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;CWD
ALIGN 16
cpu_cwd:
	mov			r8,rcx
	mov			r9,rdx
	mov			rax,[r8]
	mov			rdx,[r9]
	cwd
	mov			[r8],rax
	mov			[r9],rdx
	mov			eax,E_OK
	ret

;CDQ
ALIGN 16
cpu_cdq:
	mov			r8,rcx
	mov			r9,rdx
	mov			rax,[r8]
	mov			rdx,[r9]
	cdq
	mov			[r8],rax
	mov			[r9],rdx
	mov			eax,E_OK
	ret

;CQO
ALIGN 16
cpu_cqo:
	mov			r8,rcx
	mov			r9,rdx
	mov			rax,[r8]
	mov			rdx,[r9]
	cqo
	mov			[r8],rax
	mov			[r9],rdx
	mov			eax,E_OK
	ret

;DEC
ALIGN 16
cpu_dec:
	E1
	ALIGN 16
.0: dec			dl 
	ret
	ALIGN 16
.1:	dec			dh
	ret
	ALIGN 16
.2:	dec			dx
	ret
	ALIGN 16
.3: dec			edx
	ret
	ALIGN 16
.4:	dec			rdx
	ret
	ALIGN 16
.5: push		rdx
	dec			dword ptr [rsp]
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL, LH, LW, LD, LQ, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.jmptable: dq .0, .1, .2, .3, .4
ALIGN 16
.membound: db D1, D2, D4, D8, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.memtable: dq .0, .2, .5, .4

;DIV
ALIGN 16
cpu_div:
	E3
	ALIGN 16
.0: div			cl
	ret
	ALIGN 16
.1: div			ch
	ret
	ALIGN 16
.2: div			cx
	ret
	ALIGN 16
.3: div			ecx
	ret
	ALIGN 16
.4: div			rcx
	ret
ALIGN 16
.jmpbound: dw LL|00|00, LH|00|00, LW|00|00, LD|00|00, LQ|00|00, 00|00|00, 00|00|00, 00|00|00
.jmptable: dq    .0,       .1,       .2,       .3,       .4
ALIGN 16
.membound: db D1|00|00, D2|00|00, D4|00|00, D8|00|00, 00|00|00, 00|00|00, 00|00|00, 00|00|00
.memtable: dq    .0,       .2,       .3,       .4

;IDIV
ALIGN 16
cpu_idiv:
	E3
	ALIGN 16
.0: idiv		cl
	ret
	ALIGN 16
.1: idiv		ch
	ret
	ALIGN 16
.2: idiv		cx
	ret
	ALIGN 16
.3: idiv		ecx
	ret
	ALIGN 16
.4: idiv		rcx
	ret
ALIGN 16
.jmpbound: dw LL|00|00, LH|00|00, LW|00|00, LD|00|00, LQ|00|00, 00|00|00, 00|00|00, 00|00|00
.jmptable: dq    .0,       .1,       .2,       .3,       .4
ALIGN 16
.membound: db D1|00|00, D2|00|00, D4|00|00, D8|00|00, 00|00|00, 00|00|00, 00|00|00, 00|00|00
.memtable: dq    .0,       .2,       .3,       .4

;IMUL
ALIGN 16
cpu_imul:
	E3
	ALIGN 16
.0: imul		cl
	ret
	ALIGN 16
.1: imul		ch
	ret
	ALIGN 16
.2: imul		cx
	ret
	ALIGN 16
.3: imul		ecx
	ret
	ALIGN 16
.4: imul		rcx
	ret
ALIGN 16
.jmpbound: dw LL|00|00, LH|00|00, LW|00|00, LD|00|00, LQ|00|00, 00|00|00, 00|00|00, 00|00|00
.jmptable: dq    .0,       .1,       .2,       .3,       .4
ALIGN 16
.membound: db D1|00|00, D2|00|00, D4|00|00, D8|00|00, 00|00|00, 00|00|00, 00|00|00, 00|00|00
.memtable: dq    .0,       .2,       .3,       .4

;IMUL2
ALIGN 16
cpu_imul2:
	E2
	ALIGN 16
.0: imul		dx,cx
	ret
	ALIGN 16
.1: imul		edx,ecx
	ret
	ALIGN 16
.2: imul		rdx,rcx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .2
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;IMUL3
ALIGN 16
cpu_imul3:
	E3
	ALIGN 16
.0: mov			r8,rdx
	imul		r8w,cx
	mov			ax,r8w
	ret
	ALIGN 16
.1: mov			r8,rdx
	imul		r8d,ecx
	mov			eax,r8d
	ret
	ALIGN 16
.2: mov			r8,rdx
	imul		r8,rcx
	mov			rax,r8
	ret
ALIGN 16 
.jmpbound: dw LW|RW|X1, LW|RW|X2, LD|RD|X1, LD|RD|X4, LQ|RQ|X1, LQ|RQ|X4, 00|00|00, 00|00|00
.jmptable: dq    .0,       .0,       .1,       .1,       .2,       .2
ALIGN 16
.membound: dw LW|S2|X1, LW|S2|X2, LD|S4|X1, LD|S4|X4, LQ|S8|X1, LQ|S8|X4, 00|00|00, 00|00|00
.memtable: dq    .0,       .0,       .1,       .1,       .2,       .2

;INC
ALIGN 16
cpu_inc:
	E1
	ALIGN 16
.0: inc			dl 
	ret
	ALIGN 16
.1:	inc			dh
	ret
	ALIGN 16
.2:	inc			dx
	ret
	ALIGN 16
.3: inc			edx
	ret
	ALIGN 16
.4:	inc			rdx
	ret
	ALIGN 16
.5: push		rdx
	inc			dword ptr [rsp]
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL, LH, LW, LD, LQ, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.jmptable: dq .0, .1, .2, .3, .4
ALIGN 16
.membound: db D1, D2, D4, D8, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.memtable: dq .0, .2, .5, .4

;JCC
ALIGN 16
cpu_jcc:
	push		0
	test		r9d,IMM
	jz			.break
	test		r9d,MM
	jnz			.break
	mov			r11d,r9d
	shr			r11d,16
	and			r11d,0x000000FF
	cmp			r11d,29
	ja			.break
	mov			r10d,r9d
	shr			r10d,4
	and			r10d,7
	and			r9d,0x0F
	jmp			[.imm+r10*8]

	ALIGN 16
.2: movsx		rdx,byte ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.3: cmp			r9d,LQ
	je			.break
	movsx		rdx,word ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.4:	movsxd		rdx,dword ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	
	ALIGN 16
.continue:
	mov			rax,[rcx]
	mov			rdx,[rdx]
	mov			r8d,[r8]
	EFLAGS		r8d
	jmp			[.jcc+r11*8]

.j00:ja			.rip 
	 jmp		.nop
.j01:jae		.rip 
	 jmp		.nop
.j02:jb			.rip 
	 jmp		.nop
.j03:jbe		.rip 
	 jmp		.nop
.j04:jc			.rip 
	 jmp		.nop
.j05:je			.rip 
	 jmp		.nop
.j06:jg			.rip 
	 jmp		.nop
.j07:jge		.rip 
	 jmp		.nop
.j08:jl			.rip 
	 jmp		.nop
.j09:jle		.rip 
	 jmp		.nop
.j10:jna		.rip 
	 jmp		.nop
.j11:jnae		.rip 
	 jmp		.nop
.j12:jnb		.rip 
	 jmp		.nop
.j13:jnbe		.rip 
	 jmp		.nop
.j14:jnc		.rip 
	 jmp		.nop
.j15:jne		.rip 
	 jmp		.nop
.j16:jng		.rip 
	 jmp		.nop
.j17:jnge		.rip 
	 jmp		.nop
.j18:jnl		.rip 
	 jmp		.nop
.j19:jnle		.rip 
	 jmp		.nop
.j20:jno		.rip 
	 jmp		.nop
.j21:jnp		.rip 
	 jmp		.nop
.j22:jns		.rip 
	 jmp		.nop
.j23:jnz		.rip 
	 jmp		.nop
.j24:jo			.rip 
	 jmp		.nop
.j25:jp			.rip 
	 jmp		.nop
.j26:jpe		.rip 
	 jmp		.nop
.j27:jpo		.rip 
	 jmp		.nop
.j28:js			.rip 
	 jmp		.nop
.j29:jz			.rip
	 jmp		.nop
	 
ALIGN 16
.rip:
	cmp			r9d,LQ
	je			.64
	cmp			r9d,LD
	je			.32
	jmp			.break
ALIGN 16
.64:lea			rax,[rax+rdx]
	mov			[rcx],rax
	mov			eax,E_OK
	pop			rdx
	ret
ALIGN 16
.32:lea			eax,[eax+edx]
	mov			[rcx],rax
	mov			eax,E_OK
	pop			rdx
	ret

ALIGN 16
.nop:
	cmp			r9d,LQ
	je			.false64
	cmp			r9d,LD
	je			.false32
	jmp			.break

ALIGN 16
.false32:
	mov			eax,eax
	mov			[rcx],rax

.false64:
	mov			eax,E_FALSE
	pop			rdx
	ret

.break:
	mov			eax,E_ERROR
	pop			rdx
	ret
				
ALIGN 16
.imm: dq .break, .break, .2, .3, .4, .break, .break, .break
.jcc: dq .j00,.j01,.j02,.j03,.j04,.j05,.j06,.j07,.j08,.j09,.j10,.j11,.j12,.j13,.j14,.j15,.j16,.j17,.j18,.j19,.j20,.j21,.j22,.j23,.j24,.j25,.j26,.j27,.j28,.j29

;JMP
ALIGN 16
cpu_jmp:
	E2
	ALIGN 16
.0: mov			edx,ecx
	ret
	ALIGN 16
.1: mov			rdx,rcx
	ret
	ALIGN 16
.2: lea			edx,[edx+ecx]
	ret
	ALIGN 16
.3: lea			rdx,[rdx+rcx]
	ret
	
ALIGN 16
.jmpbound: db LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1
ALIGN 16
.membound: db LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1
ALIGN 16
.immbound: db LD|I1, LD|I2, LD|I4, LQ|I1, LQ|I4, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .2,    .2,    .2,    .3,    .3

;LEA
ALIGN 16
cpu_lea:
	mov			r10,rcx
	movzx		eax,byte ptr [rsp+0x28]
	test		eax,IMM
	jnz			.break
	movd		xmm0,eax
	pcmpistri   xmm0,[.jmpbound],0x00
	jae			.break
	mov			r11,[.jmptable+rcx*8]
	mov			ecx,dword ptr [rsp+0x28]
	shr			ecx,16
	cmp			cl,3
	ja			.break
	mov			rax,[r8]
	mov			r8,[rdx]
	mov			rdx,[r10]
	jmp			r11
	ALIGN 16
.0:	shl			eax,cl
	add			eax,r8d
	mov			r9d,r9d
	lea			dx,[eax+r9d]
	mov			[r10],rdx
	mov			eax,E_OK
	ret
	ALIGN 16
.1:	shl			rax,cl
	add			rax,r8
	movsx		r9,r9d
	lea			dx,[rax+r9]
	mov			[r10],rdx
	mov			eax,E_OK
	ret
	ALIGN 16
.2: shl			eax,cl
	add			eax,r8d
	mov			r9d,r9d
	lea			edx,[eax+r9d]
	mov			[r10],rdx
	mov			eax,E_OK
	ret
	ALIGN 16
.3:	shl			rax,cl
	add			rax,r8
	movsx		r9,r9d
	lea			edx,[rax+r9]
	mov			[r10],rdx
	mov			eax,E_OK
	ret
	ALIGN 16
.4:	shl			eax,cl
	add			eax,r8d
	mov			r9d,r9d
	lea			rdx,[eax+r9d]
	mov			[r10],rdx
	mov			eax,E_OK
	ret
	ALIGN 16
.5:	shl			rax,cl
	add			rax,r8
	movsx		r9,r9d
	lea			rdx,[rax+r9]
	mov			[r10],rdx
	mov			eax,E_OK
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.jmpbound: db LW|RD, LW|RQ, LD|RD, LD|RQ, LQ|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5

;LODS
ALIGN 16
cpu_lods:
	movzx		eax,byte ptr [rsp+0x28]
	test		eax,IMM
	jnz			.break
	mov			r10,rcx
	mov			r11,rdx
	movd		xmm0,eax
	pcmpistri	xmm0,[.lodsbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	push		rsi
	mov			rsi,r8
	mov			rax,[r10]
	mov			edx,[r9]
	EFLAGS		edx
	jmp			[.lodstable+rcx*8]

	ALIGN 16
.0: lodsb
	jmp			.continue
	ALIGN 16
.1:	lodsw
	jmp			.continue
	ALIGN 16
.2:	lodsd
	jmp			.continue
	ALIGN 16
.3:	lodsq
	jmp			.continue

ALIGN 16
.continue:
	pushfq	
	pop			rdx
	mov			[r9],edx
	mov			[r10],rax
	sub			r8,rsi
	sub			[r11],r8
	mov			eax,E_OK
	pop			rsi
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.lodsbound: db LL|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.lodstable: dq   .0,    .1,   .2,    .3

;MOV
ALIGN 16
cpu_mov:
	E2
	ALIGN 16
.0: mov			dl,cl
	ret
	ALIGN 16
.1: mov			dl,ch
	ret
	ALIGN 16
.2: mov			dh,cl
	ret
	ALIGN 16
.3:	mov			dh,ch
	ret
	ALIGN 16
.4:	mov			dx,cx
	ret
	ALIGN 16
.5:	mov			edx,ecx
	ret
	ALIGN 16
.6:	mov			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	mov			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I2, LD|I4, LQ|I4, LQ|I8, D1|I1, D2|I2, D4|I4, D8|I4, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .4,    .5,    .6,    .6,    .0,    .4,    .7,    .6

;MOVS
ALIGN 16
cpu_movs:
	movzx		eax,byte ptr [rsp+0x30]
	test		eax,IMM
	jnz			.break
	mov			r10,rcx
	mov			r11,rdx
	movd		xmm0,eax
	pcmpistri	xmm0,[.movsbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	push		rsi
	push		rdi
	mov			rsi,r8
	mov			rdi,r9
	mov			rax,[rsp+0x38]
	mov			edx,[rax]
	EFLAGS		edx
	jmp			[.movstable+rcx*8]

	ALIGN 16
.0: movsb
	jmp			.continue
	ALIGN 16
.1:	movsw
	jmp			.continue
	ALIGN 16
.2:	movsd
	jmp			.continue
	ALIGN 16
.3:	movsq
	jmp			.continue

.continue:	
	pushfq
	pop			rdx
	mov			[rax],edx
	sub			r8,rsi
	sub			[r10],r8
	sub			r9,rdi
	sub			[r11],r9
	mov			eax,E_OK
	pop			rdi
	pop			rsi
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.movsbound: db D1|S1, D2|S2, D4|S4, D8|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.movstable: dq  .0,    .1,    .2,    .3

;MOVSX
ALIGN 16
cpu_movsx:
	E2
	ALIGN 16
.0: movsx		dx,cl 
	ret
	ALIGN 16
.1:	movsx		dx,ch
	ret
	ALIGN 16
.2:	movsx		edx,cl
	ret
	ALIGN 16
.3: movsx		edx,ch
	ret
	ALIGN 16
.4:	movsx		edx,cx
	ret
	ALIGN 16
.5: movsx		rdx,cl
	ret
	ALIGN 16
.6: movsx		rdx,cx
	ret
ALIGN 16
.jmpbound: db LW|RL, LW|RH, LD|RL, LD|RH, LD|RW, LQ|LL, LQ|RW, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db LW|S1, LD|S1, LQ|S1, LD|S2, LQ|S2, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4,    .6
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;MOVSXD
ALIGN 16
cpu_movsxd:
	E2
	ALIGN 16
.0: movsxd		rdx,ecx
	ret
ALIGN 16
.jmpbound: db LQ|RW, LQ|RD, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .0
ALIGN 16
.membound: db LQ|S2, LQ|S4, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .0
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;MOVZX
ALIGN 16
cpu_movzx:
	E2
	ALIGN 16
.0: movzx		dx,cl 
	ret
	ALIGN 16
.1:	movzx		dx,ch
	ret
	ALIGN 16
.2:	movzx		edx,cl
	ret
	ALIGN 16
.3: movzx		edx,ch
	ret
	ALIGN 16
.4:	movzx		edx,cx
	ret
	ALIGN 16
.5: movzx		rdx,cl
	ret
	ALIGN 16
.6: movzx		rdx,cx
	ret
ALIGN 16
.jmpbound: db LW|RL, LW|RH, LD|RL, LD|RH, LD|RW, LQ|LL, LQ|RW, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db LW|S1, LD|S1, LQ|S1, LD|S2, LQ|S2, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4,    .6
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;MUL
ALIGN 16
cpu_mul:
	E3
	ALIGN 16
.0: mul			cl
	ret
	ALIGN 16
.1: mul			ch
	ret
	ALIGN 16
.2: mul			cx
	ret
	ALIGN 16
.3: mul			ecx
	ret
	ALIGN 16
.4: mul			rcx
	ret
ALIGN 16
.jmpbound: dw LL|00|00, LH|00|00, LW|00|00, LD|00|00, LQ|00|00, 00|00|00, 00|00|00, 00|00|00
.jmptable: dq    .0,       .1,       .2,       .3,       .4
ALIGN 16
.membound: db D1|00|00, D2|00|00, D4|00|00, D8|00|00, 00|00|00, 00|00|00, 00|00|00, 00|00|00
.memtable: dq    .0,       .2,       .3,       .4

;NEG
ALIGN 16
cpu_neg:
	E1
	ALIGN 16
.0: neg			dl 
	ret
	ALIGN 16
.1:	neg			dh
	ret
	ALIGN 16
.2:	neg			dx
	ret
	ALIGN 16
.3: neg			edx
	ret
	ALIGN 16
.4:	neg			rdx
	ret
	ALIGN 16
.5: push		rdx
	neg			dword ptr [rsp]
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL, LH, LW, LD, LQ, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.jmptable: dq .0, .1, .2, .3, .4
ALIGN 16
.membound: db D1, D2, D4, D8, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.memtable: dq .0, .2, .5, .4

;NOP
ALIGN 16
cpu_nop:
	nop
	mov			eax,E_OK
	ret

;NOT
ALIGN 16
cpu_not:
	E1
	ALIGN 16
.0: not			dl 
	ret
	ALIGN 16
.1:	not			dh
	ret
	ALIGN 16
.2:	not			dx
	ret
	ALIGN 16
.3: not			edx
	ret
	ALIGN 16
.4:	not			rdx
	ret
	ALIGN 16
.5: push		rdx
	not			dword ptr [rsp]
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL, LH, LW, LD, LQ, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.jmptable: dq .0, .1, .2, .3, .4
ALIGN 16
.membound: db D1, D2, D4, D8, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00, 00
.memtable: dq .0, .2, .5, .4

;OR
ALIGN 16
cpu_or:
	E2
	ALIGN 16
.0: or			dl,cl
	ret
	ALIGN 16
.1: or			dl,ch
	ret
	ALIGN 16
.2: or			dh,cl
	ret
	ALIGN 16
.3:	or			dh,ch
	ret
	ALIGN 16
.4:	or			dx,cx
	ret
	ALIGN 16
.5:	or			edx,ecx
	ret
	ALIGN 16
.6:	or			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	or			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;PAUSE
ALIGN 16
cpu_pause:
	pause
	mov			eax,E_OK
	ret

;POP
ALIGN 16
cpu_pop:
	mov			eax,[rsp+0x28]
	test		eax,IMM
	jnz			.break
	test		eax,LM
	jnz			.break
	mov			r10,rcx
	movzx		eax,al
	movd		xmm0,eax
	pcmpistri	xmm0,[.popbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	mov			r11,[.poptable+rcx*8]
	mov			rax,[r10]
	mov			rcx,[r8]
	jmp			r11

	ALIGN 16
.0:	lea			eax,[eax+2]
	mov			[r10],rax
	mov			[rdx],cx
	mov			eax,E_OK
	ret
	ALIGN 16	
.1:	lea			eax,[eax+4]
	mov			[r10],rax
	mov			[rdx],ecx
	mov			eax,E_OK
	ret
	ALIGN 16
.2:	lea			rax,[rax+2]
	mov			[r10],rax
	mov			[rdx],cx
	mov			eax,E_OK
	ret
	ALIGN 16
.3:	lea			rax,[rax+8]
	mov			[r10],rax
	mov			[rdx],rcx
	mov			eax,E_OK
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.popbound: db LD|RW, LD|RD, LD|S2, LD|S4, LQ|RW, LQ|RQ, LQ|S2, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.poptable: dq  .0,    .1,    .0,    .1,    .2,    .3,    .2,    .3

;POPF
ALIGN 16
cpu_popf:
	mov			eax,E_ERROR
	test		r9d,IMM
	jnz			.exit
	test		r9d,LM
	jnz			.exit
	push		r9
	sub			rsp,0x20
	mov			r9,r8
	mov			r8,rdx
	mov			rdx,r9
	call		cpu_pop
	add			rsp,0x28

.exit:
	ret

;POPFW
ALIGN 16
cpu_popfw:
	and			r9d,0xFFFFFF0F
	or			r9d,RW
	jmp			cpu_popf

;POPFD
ALIGN 16
cpu_popfd:
	and			r9d,0xFFFFFF0F
	or			r9d,RD
	jmp			cpu_popf

;POPFQ
ALIGN 16
cpu_popfq:
	and			r9d,0xFFFFFF0F
	or			r9d,RQ
	jmp			cpu_popf
		
;POPCNT
ALIGN 16
cpu_popcnt:
	E2
	ALIGN 16
.0: popcnt		dx,cx 
	ret
	ALIGN 16
.1:	popcnt		edx,ecx
	ret
	ALIGN 16
.2:	popcnt		rdx,rcx
	ret
ALIGN 16
.jmpbound: db LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2
ALIGN 16
.membound: db LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .2
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;PUSH
ALIGN 16
cpu_push:
	push		0
	mov			r10,rcx
	mov			eax,[rsp+0x30]
	movzx		ecx,al
	movd		xmm0,ecx
	pcmpistri	xmm0,[.pushbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	test		eax,IMM
	jz			.continue
	shr			eax,4
	and			eax,7
	jmp			[.size+rax*8]

	ALIGN 16
.i1:movsx		rdx,byte ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.i2:movsx		rdx,word ptr [rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue
	ALIGN 16
.i4:movsxd		rdx,[rdx]
	mov			[rsp],rdx
	mov			rdx,rsp
	jmp			.continue

	ALIGN 16
.continue:
	mov			r11,[.pushtable+rcx*8]
	mov			rax,[r10]
	mov			rcx,[rdx]
	mov			rdx,[r8]
	jmp			r11		

	ALIGN 16
.0:	lea			eax,[eax-2]
	mov			[r10],rax
	mov			[r8],cx
	mov			eax,E_OK
	pop			rdx
	ret
	ALIGN 16	
.1:	lea			eax,[eax-4]
	mov			[r10],rax
	mov			[r8],ecx
	mov			eax,E_OK
	pop			rdx
	ret
	ALIGN 16
.2:	lea			rax,[rax-2]
	mov			[r10],rax
	mov			[r8],cx
	mov			eax,E_OK
	pop			rdx
	ret
	ALIGN 16
.3:	lea			rax,[rax-8]
	mov			[r10],rax
	mov			[r8],rcx
	mov			eax,E_OK
	pop			rdx
	ret

.break:
	mov			eax,E_ERROR
	pop			rdx
	ret
ALIGN 16
.pushbound: db LD|RW, LD|RD, LD|S2, LD|S4, LD|I1, LD|I2, LD|I4, LQ|RW, LQ|RQ, LQ|S2, LQ|S8, LQ|I1, LQ|I4, 00|00, 00|00, 00|00
.pushtable: dq  .0,    .1,    .0,    .1,    .1,    .0,    .1,    .2,    .3,    .2,    .3,    .3,    .3
.size: dq .break, .break, .i1, .i2, .i4, .break, .break, .break

;PUSHF
ALIGN 16
cpu_pushf:
	mov			eax,E_ERROR
	test		r9d,IMM
	jnz			.exit
	test		r9d,LM
	jnz			.exit
	push		r9
	sub			rsp,0x20
	mov			r9,r8
	mov			r8,rdx
	mov			rdx,r9
	call		cpu_push
	add			rsp,0x28

.exit:
	ret

;PUSHFW
ALIGN 16
cpu_pushfw:
	and			r9d,0xFFFFFF0F
	or			r9d,RW
	jmp			cpu_pushf

;PUSHFD
ALIGN 16
cpu_pushfd:
	and			r9d,0xFFFFFF0F
	or			r9d,RD
	jmp			cpu_pushf

;PUSHFQ
ALIGN 16
cpu_pushfq:
	and			r9d,0xFFFFFF0F
	or			r9d,RQ
	jmp			cpu_pushf

;RCL
ALIGN 16
cpu_rcl:	
	E2
	ALIGN 16
.0: rcl			dl,cl
	ret
	ALIGN 16
.1: rcl			dh,cl
	ret
	ALIGN 16
.2:	rcl			dx,cl
	ret
	ALIGN 16
.3: rcl			edx,cl
	ret
	ALIGN 16
.4: rcl			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	rcl			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;RCR
ALIGN 16
cpu_rcr:	
	E2
	ALIGN 16
.0: rcr			dl,cl
	ret
	ALIGN 16
.1: rcr			dh,cl
	ret
	ALIGN 16
.2:	rcr			dx,cl
	ret
	ALIGN 16
.3: rcr			edx,cl
	ret
	ALIGN 16
.4: rcr			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	rcr			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;ROL
ALIGN 16
cpu_rol:	
	E2
	ALIGN 16
.0: rol			dl,cl
	ret
	ALIGN 16
.1: rol			dh,cl
	ret
	ALIGN 16
.2:	rol			dx,cl
	ret
	ALIGN 16
.3: rol			edx,cl
	ret
	ALIGN 16
.4: rol			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	rol			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;ROR
ALIGN 16
cpu_ror:	
	E2
	ALIGN 16
.0: ror			dl,cl
	ret
	ALIGN 16
.1: ror			dh,cl
	ret
	ALIGN 16
.2:	ror			dx,cl
	ret
	ALIGN 16
.3: ror			edx,cl
	ret
	ALIGN 16
.4: ror			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	ror			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;RDTSC
cpu_rdtsc:
	push		rcx
	push		rdx
	rdtsc
	pop			r9
	mov			[r9],rdx
	pop			r9
	mov			[r9],rax
	mov			eax,E_OK
	ret

;RDTSCP
cpu_rdtscp:
	push		rcx
	push		rdx
	push		r8
	rdtscp
	pop			r9
	mov			[r9],rdx
	pop			r9
	mov			[r9],rcx
	pop			r9
	mov			[r9],rax
	mov			eax,E_OK
	ret

;SAL
ALIGN 16
cpu_sal:	
	E2
	ALIGN 16
.0: sal			dl,cl 
	ret
	ALIGN 16
.1:	sal			dh,cl
	ret
	ALIGN 16
.2:	sal			dx,cl
	ret
	ALIGN 16
.3: sal			edx,cl
	ret
	ALIGN 16
.4:	sal			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	sal			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;SAR
ALIGN 16
cpu_sar:	
	E2
	ALIGN 16
.0: sar			dl,cl 
	ret
	ALIGN 16
.1:	sar			dh,cl
	ret
	ALIGN 16
.2:	sar			dx,cl
	ret
	ALIGN 16
.3: sar			edx,cl
	ret
	ALIGN 16
.4:	sar			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	sar			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;SHL
ALIGN 16
cpu_shl:	
	E2
	ALIGN 16
.0: shl			dl,cl 
	ret
	ALIGN 16
.1:	shl			dh,cl
	ret
	ALIGN 16
.2:	shl			dx,cl
	ret
	ALIGN 16
.3: shl			edx,cl
	ret
	ALIGN 16
.4:	shl			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	shl			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;SHR
ALIGN 16
cpu_shr:	
	E2
	ALIGN 16
.0: shr			dl,cl 
	ret
	ALIGN 16
.1:	shr			dh,cl
	ret
	ALIGN 16
.2:	shr			dx,cl
	ret
	ALIGN 16
.3: shr			edx,cl
	ret
	ALIGN 16
.4:	shr			rdx,cl
	ret
	ALIGN 16
.5:	push		rdx
	shr			dword ptr [rsp],cl
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RL, LW|RL, LD|RL, LQ|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4
ALIGN 16
.membound: db D1|RL, D2|RL, D4|RL, D8|RL, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .2,    .5,    .4
ALIGN 16
.immbound: db LL|I1, LH|I1, LW|I1, LD|I1, LQ|I1, D1|I1, D2|I1, D4|I1, D8|I1, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .1,    .2,    .3,    .4,    .0,    .2,    .5,    .4

;SBB
ALIGN 16
cpu_sbb:
	E2
	ALIGN 16
.0: sbb			dl,cl
	ret
	ALIGN 16
.1: sbb			dl,ch
	ret
	ALIGN 16
.2: sbb			dh,cl
	ret
	ALIGN 16
.3:	sbb			dh,ch
	ret
	ALIGN 16
.4:	sbb			dx,cx
	ret
	ALIGN 16
.5:	sbb			edx,ecx
	ret
	ALIGN 16
.6:	sbb			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	sbb			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;SCAS
ALIGN 16
cpu_scas:
	movzx		eax,byte ptr [rsp+0x28]
	test		eax,IMM
	jnz			.break
	mov			r10,rcx
	mov			r11,rdx
	movd		xmm0,eax
	pcmpistri	xmm0,[.scasbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	push		rdi
	mov			rdi,r8
	mov			rax,[r10]
	mov			edx,[r9]
	EFLAGS		edx
	jmp			[.scastable+rcx*8]

	ALIGN 16
.0: scasb
	jmp			.continue
	ALIGN 16
.1:	scasw
	jmp			.continue
	ALIGN 16
.2:	scasd
	jmp			.continue
	ALIGN 16
.3:	scasq
	jmp			.continue

ALIGN 16
.continue:
	pushfq	
	pop			rdx
	mov			[r9],edx
	mov			[r10],rax
	sub			r8,rdi
	sub			[r11],r8
	mov			eax,E_OK
	pop			rsi
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.scasbound: db LL|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.scastable: dq   .0,    .1,   .2,    .3

;SETCC
ALIGN 16
cpu_setcc:
	test		r8d,IMM
	jnz			.break
	mov			eax,r8d
	shr			eax,16
	and			eax,0xFF
	cmp			eax,29
	ja			.break
	and			r8d,0x0F
	cmp			r8d,LL
	je			.next
	cmp			r8d,D1
	je			.next
	cmp			r8d,LH
	jne			.break
	xor			r8d,r8d

.next:
	mov			edx,[rdx]
	EFLAGS		edx
	jmp			[.setcc+rax*8]

.s00:seta		al 
	 jmp		.continue
.s01:setae		al 
	 jmp		.continue
.s02:setb		al 
	 jmp		.continue
.s03:setbe		al 
	 jmp		.continue
.s04:setc		al 
	 jmp		.continue
.s05:sete		al 
	 jmp		.continue
.s06:setg		al 
	 jmp		.continue
.s07:setge		al 
	 jmp		.continue
.s08:setl		al 
	 jmp		.continue
.s09:setle		al 
	 jmp		.continue
.s10:setna		al 
	 jmp		.continue
.s11:setnae		al 
	 jmp		.continue
.s12:setnb		al 
	 jmp		.continue
.s13:setnbe		al 
	 jmp		.continue
.s14:setnc		al 
	 jmp		.continue
.s15:setne		al 
	 jmp		.continue
.s16:setng		al 
	 jmp		.continue
.s17:setnge		al 
	 jmp		.continue
.s18:setnl		al 
	 jmp		.continue
.s19:setnle		al 
	 jmp		.continue
.s20:setno		al 
	 jmp		.continue
.s21:setnp		al 
	 jmp		.continue
.s22:setns		al 
	 jmp		.continue
.s23:setnz		al 
	 jmp		.continue
.s24:seto		al 
	 jmp		.continue
.s25:setp		al 
	 jmp		.continue
.s26:setpe		al 
	 jmp		.continue
.s27:setpo		al 
	 jmp		.continue
.s28:sets		al 
	 jmp		.continue
.s29:setz		al
	 jmp		.continue

ALIGN 16
.continue:
	test		r8d,r8d
	setz		r8b
	mov			[rcx+r8],al
	xor			eax,E_FALSE
	ret
	
.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.setcc: dq .s00,.s01,.s02,.s03,.s04,.s05,.s06,.s07,.s08,.s09,.s10,.s11,.s12,.s13,.s14,.s15,.s16,.s17,.s18,.s19,.s20,.s21,.s22,.s23,.s24,.s25,.s26,.s27,.s28,.s29

;SHLD
ALIGN 16
cpu_shld:
	E3
	ALIGN 16
.0:	shld		ax,dx,cl
	ret
	ALIGN 16
.1:	shld		eax,edx,cl
	ret
	ALIGN 16
.2:	shld		rax,rdx,cl
	ret
	ALIGN 16
.3:	push		rax
	shld		dword ptr [rsp],edx,cl
	pop			rax
	ret
ALIGN 16
.jmpbound: dw LW|RW|R3L, LW|RW|X1, LD|RD|R3L, LD|RD|X1, LQ|RQ|R3L, LQ|RQ|X1, 00|00|00, 00|00|00
.jmptable: dq	 .0,        .0,       .1,        .1,       .2,        .2
ALIGN 16
.membound: dw D2|RW|R3L, D2|RW|X1, D4|RD|R3L, D4|RD|X1, D8|RQ|R3L, D8|RQ|X1, 00|00|00, 00|00|00
.memtable: dq    .0,        .0,       .3,        .3,       .2,        .2

;SHRD
ALIGN 16
cpu_shrd:
	E3
	ALIGN 16
.0:	shrd		ax,dx,cl
	ret
	ALIGN 16
.1:	shrd		eax,edx,cl
	ret
	ALIGN 16
.2:	shrd		rax,rdx,cl
	ret
	ALIGN 16
.3:	push		rax
	shrd		dword ptr [rsp],edx,cl
	pop			rax
	ret
ALIGN 16
.jmpbound: dw LW|RW|R3L, LW|RW|X1, LD|RD|R3L, LD|RD|X1, LQ|RQ|R3L, LQ|RQ|X1, 00|00|00, 00|00|00
.jmptable: dq	 .0,        .0,       .1,        .1,       .2,        .2
ALIGN 16
.membound: dw D2|RW|R3L, D2|RW|X1, D4|RD|R3L, D4|RD|X1, D8|RQ|R3L, D8|RQ|X1, 00|00|00, 00|00|00
.memtable: dq    .0,        .0,       .3,        .3,       .2,        .2

;STC
ALIGN 16
cpu_stc:
	or			dword ptr [rcx],CF
	mov			eax,E_OK
	ret

;STD
ALIGN 16
cpu_std:
	or			dword ptr [rcx],DF
	mov			eax,E_OK
	ret

;STOS
ALIGN 16
cpu_stos:
	movzx		eax,byte ptr [rsp+0x28]
	test		eax,IMM
	jnz			.break
	mov			r10,rcx
	mov			r11,rdx
	movd		xmm0,eax
	pcmpistri	xmm0,[.scasbound],PCMPxSTRx_UNSIGNED_BYTES
	jae			.break
	push		rdi
	mov			rdi,r8
	mov			rax,[r10]
	mov			edx,[r9]
	EFLAGS		edx
	jmp			[.scastable+rcx*8]

	ALIGN 16
.0: stosb
	jmp			.continue
	ALIGN 16
.1:	stosw
	jmp			.continue
	ALIGN 16
.2:	stosd
	jmp			.continue
	ALIGN 16
.3:	stosq
	jmp			.continue

ALIGN 16
.continue:
	pushfq	
	pop			rdx
	mov			[r9],edx
	mov			[r10],rax
	sub			r8,rdi
	sub			[r11],r8
	mov			eax,E_OK
	pop			rdi
	ret

.break:
	mov			eax,E_ERROR
	ret
ALIGN 16
.scasbound: db LL|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.scastable: dq   .0,    .1,   .2,    .3

;SUB
ALIGN 16
cpu_sub:
	E2
	ALIGN 16
.0: sub			dl,cl
	ret
	ALIGN 16
.1: sub			dl,ch
	ret
	ALIGN 16
.2: sub			dh,cl
	ret
	ALIGN 16
.3:	sub			dh,ch
	ret
	ALIGN 16
.4:	sub			dx,cx
	ret
	ALIGN 16
.5:	sub			edx,ecx
	ret
	ALIGN 16
.6:	sub			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	sub			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

;TEST
ALIGN 16
cpu_test:
	E2
	ALIGN 16
.0: test		dl,cl
	ret
	ALIGN 16
.1: test		dl,ch
	ret
	ALIGN 16
.2: test		dh,cl
	ret
	ALIGN 16
.3:	test		dh,ch
	ret
	ALIGN 16
.4:	test		dx,cx
	ret
	ALIGN 16
.5:	test		edx,ecx
	ret
	ALIGN 16
.6:	test		rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	test		dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I2, LD|I4, LQ|I4, D1|I1, D2|I2, D4|I4, D8|I4, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable: dq  .0,    .4,    .5,    .6,    .0,    .4,    .7,    .6

;XADD
cpu_xadd:
	cmp			rcx,rdx
	jne			cpu_xadd2
	jmp			cpu_xadd1

;XADD1
cpu_xadd1:
	cmp			rcx,rdx
	jne			cpu_xadd2
	E2
	ALIGN 16
.0: xadd		cl,cl
	ret
	ALIGN 16
.1: xadd		ch,ch
	ret
	ALIGN 16
.2: xadd		cl,ch
	ret
	ALIGN 16
.3: xadd		ch,cl 
	ret
	ALIGN 16
.4:	xadd		cx,cx
	ret
	ALIGN 16
.5:	xadd		ecx,ecx
	ret
	ALIGN 16
.6:	xadd		rcx,rcx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RH, LL|RH, LH|RL, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: 
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;XADD2
cpu_xadd2:
	cmp			rcx,rdx
	je			cpu_xadd1
	E2
	ALIGN 16
.0: xadd		cl,dl 
	ret
	ALIGN 16
.1: xadd		cl,dh 
	ret
	ALIGN 16
.2: xadd		ch,dl 
	ret
	ALIGN 16
.3: xadd		ch,dh 
	ret
	ALIGN 16
.4: xadd		cx,dx 
	ret
	ALIGN 16
.5: xadd		ecx,edx 
	ret
	ALIGN 16
.6: xadd		rcx,rdx 
	ret
	ALIGN 16
.7: push		rcx
	xadd		dword ptr [rsp],edx
	pop			rcx
	ret	
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00 
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;XCHG
cpu_xchg:
	cmp			rcx,rdx
	jne			cpu_xchg2
	jmp			cpu_xchg1

;XCHG1
cpu_xchg1:
	cmp			rcx,rdx
	jne			cpu_xchg2
	E2
	ALIGN 16
.0: xchg		cl,cl
	ret
	ALIGN 16
.1: xchg		ch,ch
	ret
	ALIGN 16
.2: xchg		cl,ch
	ret
	ALIGN 16
.3: xchg		ch,cl 
	ret
	ALIGN 16
.4:	xchg		cx,cx
	ret
	ALIGN 16
.5:	xchg		ecx,ecx
	ret
	ALIGN 16
.6:	xchg		rcx,rcx
	ret
ALIGN 16
.jmpbound: db LL|RL, LH|RH, LL|RH, LH|RL, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: 
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;XCHG2
cpu_xchg2:
	cmp			rcx,rdx
	je			cpu_xchg1
	E2
	ALIGN 16
.0: xchg		cl,dl 
	ret
	ALIGN 16
.1: xchg		cl,dh 
	ret
	ALIGN 16
.2: xchg		ch,dl 
	ret
	ALIGN 16
.3: xchg		ch,dh 
	ret
	ALIGN 16
.4: xchg		cx,dx 
	ret
	ALIGN 16
.5: xchg		ecx,edx 
	ret
	ALIGN 16
.6: xchg		rcx,rdx 
	ret
	ALIGN 16
.7: push		rcx
	xchg		dword ptr [rsp],edx
	pop			rcx
	ret	
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00 
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6
ALIGN 16
.immbound: db 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.immtable:

;XOR
ALIGN 16
cpu_xor:
	E2
	ALIGN 16
.0: xor			dl,cl
	ret
	ALIGN 16
.1: xor			dl,ch
	ret
	ALIGN 16
.2: xor			dh,cl
	ret
	ALIGN 16
.3:	xor			dh,ch
	ret
	ALIGN 16
.4:	xor			dx,cx
	ret
	ALIGN 16
.5:	xor			edx,ecx
	ret
	ALIGN 16
.6:	xor			rdx,rcx
	ret
	ALIGN 16
.7:	push		rdx
	xor			dword ptr [rsp],ecx
	pop			rdx
	ret
ALIGN 16
.jmpbound: db LL|RL, LL|RH, LH|RL, LH|RH, LW|RW, LD|RD, LQ|RQ, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.jmptable: dq  .0,    .1,    .2,    .3,    .4,    .5,    .6
ALIGN 16
.membound: db D1|RL, D1|RH, D2|RW, D4|RD, D8|RQ, LL|S1, LH|S1, LW|S2, LD|S4, LQ|S8, 00|00, 00|00, 00|00, 00|00, 00|00, 00|00
.memtable: dq  .0,    .1,    .4,    .7,    .6,    .0,    .2,    .4,    .5,    .6
ALIGN 16
.immbound: db LL|I1, LW|I1, LW|I2, LD|I1, LD|I4, LQ|I1, LQ|I4, D1|I1, D2|I1, D2|I2, D4|I1, D4|I4, D8|I1, D8|I4, 00|00, 00|00
.immtable: dq  .0,    .4,    .4,    .5,    .5,    .6,    .6,    .0,    .4,    .4,    .7,    .7,    .6,    .6

export cpu_rex
export cpu_rextest1
export cpu_rextest2
;export cpu_aaa
;export cpu_aad
;export cpu_aam
;export cpu_aas
export cpu_adc
export cpu_add
;export cpu_adcx
;export cpu_adox
export cpu_and
;export cpu_arpl
;export cpu_bextr
;export cpu_blsi
;export cpu_blsmsk
;export cpu_blsr
;export cpu_bound
export cpu_bsf
export cpu_bsr
export cpu_bswap
export cpu_bt
export cpu_btc
export cpu_btr
export cpu_bts
;export cpu_bzhi
;export cpu_call
export cpu_cbw
export cpu_cwde
export cpu_cdqe
;export cpu_clac
export cpu_clc
export cpu_cld
;export cpu_clflush
;export cpu_cli
;export cpu_clts
export cpu_cmc
export cpu_cmovcc
export cpu_cmp
export cpu_cmps
export cpu_cmpxchg
;export cpu_cmpxchg8b
;export cpu_cmpxchg16b
export cpu_cpuid
export cpu_crc32
export cpu_cwd
export cpu_cdq
export cpu_cqo
;export cpu_daa
;export cpu_das
export cpu_dec
export cpu_div
;export cpu_enter
export cpu_idiv
export cpu_imul
export cpu_imul2
export cpu_imul3
;export cpu_in
export cpu_inc
;export cpu_int
;export cpu_invd
;export cpu_invlpd
;export cpu_invlpcid
;export cpu_iret
export cpu_jcc
export cpu_jmp
;export cpu_lahf
;export cpu_lar
;export cpu_lds
;export cpu_les
;export cpu_lfs
;export cpu_lgs
;export cpu_lss
export cpu_lea
;export cpu_leave
;export cpu_lfence
;export cpu_lgdt
;export cpu_lidt
;export cpu_lldt
;export cpu_lmsw
;export cpu_lock
export cpu_lods
;export cpu_loope
;export cpu_loopne
;export cpu_lsl
;export cpu_ltr
;export cpu_lzcnt
;export cpu_mfence
;export cpu_monitor
export cpu_mov
;export cpu_movbe
export cpu_movs
export cpu_movsx
export cpu_movsxd
export cpu_movzx
export cpu_mul
;export cpu_mulx
export cpu_neg
export cpu_nop
export cpu_not
export cpu_or
;export cpu_out
;export cpu_outs
export cpu_pause
export cpu_pop
;export cpu_popa
;export cpu_popad
export cpu_popf
export cpu_popfw
export cpu_popfd
export cpu_popfq
;export cpu_popcnt
;export cpu_prefetcht0
;export cpu_prefetcht1
;export cpu_prefetcht2
;export cpu_prefetchnta
;export cpu_prefetchw
;export cpu_prefetchwt1
export cpu_push
;export cpu_pusha
;export cpu_pushad
export cpu_pushf
export cpu_pushfw
export cpu_pushfd
export cpu_pushfq
export cpu_rcl
export cpu_rcr
export cpu_rol
export cpu_ror
;export cpu_rdfsbase
;export cpu_rdgsbase
;export cpu_rdmsr
;export cpu_rdpmc
;export cpu_rdrand
;export cpu_rdseed
export cpu_rdtsc
export cpu_rdtscp
;export cpu_rep
;export cpu_repe
;export cpu_repne
;export cpu_ret
;export cpu_rorx
;export cpu_rsm
;export cpu_sahf
export cpu_sal
export cpu_sar
export cpu_shl
export cpu_shr
;export cpu_sarx
;export cpu_shlx
;export cpu_shrx
export cpu_sbb
export cpu_scas
export cpu_setcc
;export cpu_sfence
;export cpu_sgdt
export cpu_shld
export cpu_shrd
;export cpu_sidt
;export cpu_sldt
;export cpu_smsw
;export cpu_stac
export cpu_stc
export cpu_std
;export cpu_sti
export cpu_stos
;export cpu_str
export cpu_sub
;export cpu_swapgs
;export cpu_syscall
;export cpu_sysenter
;export cpu_sysexit
;export cpu_sysret
export cpu_test
;export cpu_tzcnt
;export cpu_ud2
;export cpu_wait
;export cpu_wbinvd
;export cpu_wrfsbase
;export cpu_wrgsbase
;export cpu_wrmsr
;export cpu_xacqire
;export cpu_xrelease
;export cpu_xabort
export cpu_xadd
;export cpu_xbegin
export cpu_xchg
;export cpu_xend
;export cpu_xgetbv
;export cpu_xlat
;export cpu_xlatb
export cpu_xor
;export cpu_xrstor
;export cpu_xrstors
;export cpu_xsave
;export cpu_xsavec
;export cpu_xsaveopt
;export cpu_xsaves
;export cpu_xsetbv
;export cpu_xtest